% Num. Math. - FS 2014 - Serie 11 Uebung 2b - splines / Runges Beispiel

clear all
xx=-5:1:5;
fx=1./(1+xx.^2);

figure;
plot(xx,fx,'ko','linewidth',2);
hold on;
xplot=linspace(xx(1),xx(end),200);
plot(xplot, spline(xx,fx,xplot),'r','linewidth',2);
plot(xplot, polyval(polyfit(xx,fx,length(xx)-1),xplot)...
    ,'b','linewidth',2);
plot(xplot,1./(1+xplot.^2),'k--','linewidth',2);
hold off
legend('Nodes', 'Spline', 'Polynomial', 'f(x)')

%info:  help spline, help polyfit, help polyval

% Tschebyscheff-Knoten:
xx=5*cos(pi*(1:2:21)/22);
fx=1./(1+xx.^2);
figure;
plot(xx,fx,'ko','linewidth',2);
hold on;
xplot=linspace(xx(1),xx(end),200);
plot(xplot, spline(xx,fx,xplot),'r','linewidth',2);
plot(xplot, polyval(polyfit(xx,fx,length(xx)-1),xplot)...
    ,'b','linewidth',2);
plot(xplot,1./(1+xplot.^2),'k--','linewidth',2);
hold off
legend('Nodes', 'Spline', 'Polynomial', 'f(x)')
